<?xml version="1.0" encoding="UTF-8"?>
<?bluebottle format version="0.1" ?>
<?xml-stylesheet type="text/xsl" href="http://bluebottle.ethz.ch/bluebottle.xsl" ?>
<Text>
<Span style="Normal"><![CDATA[MODULE GUIPat13;]]></Span><Span style="Comment"><![CDATA[
	(** 	PURPOSE "Template for the construction of a GUI application which can be started only once";
		TECHNIQUE "An anchor point winstance is either NIL or points to a window";
		USAGE  "1 - Make a copy of this template and assign it a name of your choice";
				"2 - In the copy, replace all occurences of  "GUIPatW1" by the name of the new module";
		AUTHOR "afi";
	 *)]]></Span><Span style="Normal"><![CDATA[

IMPORT
	AosModules, WMComponents, WM := WMWindowManager, WMMessages,WMStandardComponents,
	Utilities, WMPopups
	;

TYPE
]]></Span><Span style="Normal"><![CDATA[	]]></Span><Span style="Bold"><![CDATA[ContextMenuPar]]></Span><Span style="Normal"><![CDATA[ = OBJECT
	VAR mode : LONGINT;

		]]></Span><Span style="Bold"><![CDATA[PROCEDURE &New(m : LONGINT);]]></Span><Span style="Normal"><![CDATA[
		BEGIN mode := m END
		New;

	END ContextMenuPar;
]]></Span><Span style="Normal"><![CDATA[
	]]></Span><Span style="Bold"><![CDATA[Window* = OBJECT (WMComponents.FormWindow)]]></Span><Span style="Normal"><![CDATA[

		VAR
]]></Span><Span style="Normal"><![CDATA[			dragging : BOOLEAN;
			lastX, lastY : LONGINT;
]]></Span><Span style="Normal"><![CDATA[
		]]></Span><Span style="Bold"><![CDATA[PROCEDURE CreateForm () : WMComponents.VisualComponent;]]></Span><Span style="Normal"><![CDATA[
		VAR panel : WMStandardComponents.Panel;
		BEGIN
			NEW (panel); panel.bounds.SetExtents (120, 40);
			
			RETURN panel
		END CreateForm;

		]]></Span><Span style="Bold"><![CDATA[PROCEDURE &New ();	(* A *)
]]></Span><Span style="Normal"><![CDATA[		VAR vc : WMComponents.VisualComponent;]]></Span><Span style="Comment"><![CDATA[
]]></Span><Span style="Normal"><![CDATA[		BEGIN
			vc := CreateForm ();
			Init (vc.bounds.GetWidth (), vc.bounds.GetHeight (), FALSE);
			SetContent (vc);
]]></Span><Span style="Normal"><![CDATA[			WM.ExtAddWindow(SELF, 50, 50, {WM.FlagStayOnTop});
]]></Span><Span style="Normal"><![CDATA[(*			WM.DefaultAddWindow (SELF);			
			SetTitle (Utilities.NewString ("AosSkelMW"));		
*)
		END New;

]]></Span><Span style="Normal"><![CDATA[		]]></Span><Span style="Bold"><![CDATA[PROCEDURE PointerDown*(x, y:LONGINT; keys:SET);
]]></Span><Span style="Normal"><![CDATA[		VAR contextMenu : WMPopups.Popup;]]></Span><Span style="Comment"><![CDATA[
		]]></Span><Span style="Normal"><![CDATA[BEGIN
]]></Span><Span style="Comment"><![CDATA[			]]></Span><Span style="Normal"><![CDATA[lastX := bounds.l+x; lastY:=bounds.t+y;
]]></Span><Span style="Comment"><![CDATA[			]]></Span><Span style="Normal"><![CDATA[IF keys = {0} THEN
]]></Span><Span style="Comment"><![CDATA[			]]></Span><Span style="Normal"><![CDATA[	dragging := TRUE
]]></Span><Span style="Comment"><![CDATA[			]]></Span><Span style="Normal"><![CDATA[ELSIF keys = {2} THEN
]]></Span><Span style="Comment"><![CDATA[			]]></Span><Span style="Normal"><![CDATA[	NEW(contextMenu);
]]></Span><Span style="Comment"><![CDATA[			]]></Span><Span style="Normal"><![CDATA[	contextMenu.Add("Close", HandleClose);
				contextMenu.Popup(bounds.l+x, bounds.t+y)
]]></Span><Span style="Comment"><![CDATA[			]]></Span><Span style="Normal"><![CDATA[END
]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Normal"><![CDATA[END PointerDown;

]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Bold"><![CDATA[PROCEDURE HandleClose(sender, par: PTR);]]></Span><Span style="Normal"><![CDATA[
]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Normal"><![CDATA[VAR manager : WM.WindowManager;
]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Normal"><![CDATA[BEGIN
]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Normal"><![CDATA[	manager := WM.GetDefaultManager();
]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Normal"><![CDATA[	manager.SetFocus(SELF);
]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Normal"><![CDATA[	Close;
]]></Span><Span style="Comment"><![CDATA[(*		]]></Span><Span style="Normal"><![CDATA[	winstance := NIL	*)
]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Normal"><![CDATA[END HandleClose;
]]></Span><Span style="Comment"><![CDATA[
		]]></Span><Span style="Bold"><![CDATA[PROCEDURE PointerMove*(x,y:LONGINT; keys:SET);
]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Normal"><![CDATA[VAR dx, dy : LONGINT;
]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Normal"><![CDATA[BEGIN
]]></Span><Span style="Comment"><![CDATA[			]]></Span><Span style="Normal"><![CDATA[IF dragging THEN 
]]></Span><Span style="Comment"><![CDATA[				]]></Span><Span style="Normal"><![CDATA[x := bounds.l + x; y := bounds.t + y; dx := x - lastX; dy := y - lastY;
]]></Span><Span style="Comment"><![CDATA[				]]></Span><Span style="Normal"><![CDATA[lastX := lastX + dx; lastY := lastY + dy;
]]></Span><Span style="Comment"><![CDATA[				]]></Span><Span style="Normal"><![CDATA[IF (dx # 0) OR (dy # 0) THEN manager.SetWindowPos(SELF, bounds.l + dx, bounds.t + dy) END
]]></Span><Span style="Comment"><![CDATA[			]]></Span><Span style="Normal"><![CDATA[END
]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Normal"><![CDATA[END PointerMove;]]></Span><Span style="Comment"><![CDATA[				]]></Span><Span style="Normal"><![CDATA[

]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Bold"><![CDATA[PROCEDURE PointerUp*(x, y:LONGINT; Keys:SET);
]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Normal"><![CDATA[BEGIN
]]></Span><Span style="Comment"><![CDATA[			]]></Span><Span style="Normal"><![CDATA[dragging := FALSE
]]></Span><Span style="Comment"><![CDATA[		]]></Span><Span style="Normal"><![CDATA[END PointerUp;
]]></Span><Span style="Normal"><![CDATA[
		(* No Close procedure required, handled by Popup menu. *)
]]></Span><Span style="Normal"><![CDATA[
]]></Span><Span style="Normal"><![CDATA[		]]></Span><Span style="Bold"><![CDATA[PROCEDURE Close ();	(* B *)]]></Span><Span style="Normal"><![CDATA[
		BEGIN

			Close^;
			winstance := NIL
		END Close;

	END Window;

VAR
	winstance : Window;

]]></Span><Span style="Bold"><![CDATA[PROCEDURE Open* (par : ANY) : ANY;]]></Span><Span style="Normal"><![CDATA[
BEGIN
	IF winstance = NIL THEN NEW (winstance) END;
	RETURN NIL
END Open;
]]></Span><Span style="Bold"><![CDATA[
PROCEDURE Cleanup;
]]></Span><Span style="Normal"><![CDATA[BEGIN]]></Span><Span style="Bold"><![CDATA[
]]></Span><Span style="Normal"><![CDATA[	IF winstance # NIL THEN winstance.Close END
END Cleanup;

BEGIN
	AosModules.InstallTermHandler (Cleanup);
	(* Additional BEGIN processing. *)
END GUIPat13.

GUIPat13.Open ~
S.Free GUIPat13  ~
]]></Span>

</Text>
